/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	port STM32L051 RFM69lib Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#include "hw.h"
#include "RFM69.h"
#include "RFM69registers.h"
#include "clock.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

//PUTCHAR_PROTOTYPE
int putchar ( int ch )
{
//			  while((USART1->ISR & USART_ISR_TC) != USART_ISR_TC)
//			  { 
//			    /* add time out here for a robust application */
//			  }
//			  USART1->ICR = USART_ICR_TCCF;/* clear TC flag */	 	  
//			  
//			  USART1->TDR = (u8)ch;

  USART1->TDR = ((u8)ch & (uint16_t)0x01FF);
  
  while(!(USART1->ISR & USART_ISR_TC));
  
  return ch;
}

// function to disable interrupts
void noInterrupts()
{
	//__disable_interrupt();
	NVIC_DisableIRQ(EXTI4_15_IRQn);
}
// function to enable interrupts
void interrupts()
{
	//__enable_interrupt();
	NVIC_EnableIRQ(EXTI4_15_IRQn);
}
// function to control the GPIO tied to RFM69 chip select (parameter HIGH or LOW)
void RFM69_SetCSPin(bool bPin)
{
	if( bPin )
		{
			CS_RF_HIGH();
		}
		else
			{
				CS_RF_LOW();
			}
}
// function to read GPIO connected to RFM69 DIO0 (RFM69 interrupt signalling)
bool RFM69_ReadDIO0Pin(void)
{
	 if( IF_GPIO0() )
	 	return true;
	 else
	 	return false;
}
// function to transfer 1byte on SPI with readback
uint8_t SPI_transfer8(uint8_t bData)
{

  /* Loop while DR register in not emplty */
  while((SPI_RF_MODUL->SR & SPI_SR_TXE) == 0);
  /* Send byte through the SPI1 peripheral */
  //SPI_SendData8( SPI_FLASH, byte );
  SPI_RF_MODUL->DR = bData;
  /* Wait to receive a byte */
  while((SPI_RF_MODUL->SR & SPI_SR_RXNE) == 0);
  /* Return the byte read from the SPI bus */
  //return SPI_ReceiveData8( SPI_FLASH );
  return SPI_RF_MODUL->DR;
  	
}
// function to print to serial port a string
//void SerialPrint(char* pData)
//{
//	  printf( pData );
//}
// function for timeout handling, checks if previously set timeout expired
bool Timeout_IsTimeout1(void)
{
	return getTimeout();
}
// function for timeout handling, sets a timeout, parameter is in milliseconds (ms)
void Timeout_SetTimeout1(uint16_t wTo)
{
	  setTickCount( wTo );
}
