/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	port STM32L051 RFM69lib Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#ifndef port_rfm69_lib_stm32l051_h
#define port_rfm69_lib_stm32l051_h


#include "hw.h"
#include "RFM69.h"
#include "RFM69registers.h"


void noInterrupts();                // function to disable interrupts
void interrupts();                  // function to enable interrupts
void RFM69_SetCSPin(bool);          // function to control the GPIO tied to RFM69 chip select (parameter HIGH or LOW)
bool RFM69_ReadDIO0Pin(void);       // function to read GPIO connected to RFM69 DIO0 (RFM69 interrupt signalling)
uint8_t SPI_transfer8(uint8_t);     // function to transfer 1byte on SPI with readback
void Serialprint(char*);            // function to print to serial port a string
bool Timeout_IsTimeout1(void);      // function for timeout handling, checks if previously set timeout expired
void Timeout_SetTimeout1(uint16_t); // function for timeout handling, sets a timeout, parameter is in milliseconds (ms)

#endif
