/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	Clock Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#ifndef _CLOCK_H_
#define _CLOCK_H_


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Time-out values */
#define HSI_TIMEOUT_VALUE          ((uint32_t)100)  /* 100 ms */
#define CLOCKSWITCH_TIMEOUT_VALUE  ((uint32_t)5000) /* 5 s    */

/* Error codes used to make the red led blinking */
#define ERROR_HSI_TIMEOUT 0x02
#define ERROR_CLKSWITCH_TIMEOUT 0x04

/* Delay value : short one is used for the error coding, long one (~1s) in case 
   of no error or between two bursts */
#define SHORT_DELAY 200
#define LONG_DELAY 1000

u16 getError( void );
void setTickCount( u32 dTick );
u32 getTickCount( void );
bool getTimeout(void);
void SystemClock_Config(void);

#endif
