/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	LED Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#ifndef _LED_H_
#define _LED_H_

#include "hw.h"


typedef enum
{
	LED_GREEN = 1,
	LED_YELLOW,
	LED_RED,
	
	LED_MAX
}T_E_LED;

typedef enum
{
	LED_GREEN_OFF,
	LED_GREEN_ON,

	LED_STATUS_GREEN_MAX
}T_E_LED_GREEN_STATUS;

typedef enum
{
  LED_RED_OFF,
	LED_RED_ON,
	
	LED_STATUS_RED_MAX
}T_E_LED_RED_STATUS;

typedef enum
{
  LED_YELLOW_OFF,
	LED_YELLOW_ON,
	
	LED_STATUS_YELLOW_MAX
}T_E_LED_YELLOW_STATUS;

T_E_LED_GREEN_STATUS getLedGreenStatus( void );
T_E_LED_RED_STATUS   getLedRedStatus( void );
T_E_LED_YELLOW_STATUS   getLedYellowStatus( void );

void setLedGreenStatus( T_E_LED_GREEN_STATUS );
void setLedRedStatus( T_E_LED_RED_STATUS );
void setLedYellowStatus( T_E_LED_YELLOW_STATUS );

void Blink(T_E_LED teLed, u32 dMs, u16 wLoops );

#endif
