/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	Macros Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/


#ifndef RFM_MACRO_H
#define RFM_MACRO_H


/* Exported macro ------------------------------------------------------------*/
/* Common routines */
#define IS_AF(c)  ((c >= 'A') && (c <= 'F'))
#define IS_af(c)  ((c >= 'a') && (c <= 'f'))
#define IS_09(c)  ((c >= '0') && (c <= '9'))
#define IS_STEUER(c) (( c == 0x02 ) && ( c == 0x03 ) && ( c == 0x06 ) && ( c == 0x15 ))
#define IS_ENTER(c)  (( c == 0x0D ))
#define IS_NEWLINE(c)  (( c == 0x0A ))
#define IS_STEUER_REM(c)  (( c == 0x0D ) || ( c == 0x0A) || (c == 0x20))
#define ISVALIDHEX(c)  IS_AF(c) || IS_af(c) || IS_09(c)
#define ISVALIDDEC(c)  IS_09(c)
#define CONVERTDEC(c)  (c - '0')

#define CONVERTHEX_alpha(c)  (IS_AF(c) ? (c - 'A'+10) : (c - 'a'+10))
#define CONVERTHEX(c)   (IS_09(c) ? (c - '0') : CONVERTHEX_alpha(c))

#define LOW_W(x)  ((short)x & 0x0FF)
#define HIGH_W(x) ((short)x >> 8)
#define LOWB_DW(x)  ((unsigned long)x & 0x000000FF)

#define BSW(x)	((((x) >> 8) & 0x00FF) | (((x) << 8) & 0xFF00))

#define MINIMUM(x,y) ((x<y) ? x : y)
#define MAXIMUM(x,y) ((x>y) ? x : y)

#endif
