/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  08.02.2017 19:19:10
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*  Headerfile
*  ----------
*  Fuer allgemeine Dinge des Projekts
* 
*
******************************************************************************/
#ifndef TYPES_H
#define TYPES_H

//allgemeine Define's *********************************************************

//- Datentypen ----------------------------------------------------------------

//#ifndef __WIN32__
//#include <stdint.h>
//typedef unsigned char BOOL;
//#endif
        


typedef unsigned long  u32;
typedef unsigned short u16;
typedef unsigned char  u8;   

typedef signed short s16;

typedef enum {
   HSI_OFF  = 0x00,          // HSI ein
   HSI_ON   = 0x01,          // HSI aus
   HSI_DIV4 = 0x09           // HSI Div4
} HSI_OSC;




#ifndef INLINE
#define INLINE
#endif

#ifndef NULL
#define NULL 0
#endif

//typedef enum {FALSE = 0, TRUE = !FALSE} bool;


#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif



typedef enum {
   EIN,                      // Schalter ein
   AUS                        // Schalter aus
   } Schalter;

#ifndef __C51__
typedef unsigned long DWORD;	//   Type DWORD definition
#endif

#ifndef WORD
typedef unsigned short WORD;	//   Type WORD definition
#endif

#ifndef SHORT
typedef short SHORT;	         //   Type SHORT definition
#endif

#ifndef CHAR
typedef char CHAR;	         //   Type CHAR definition
#endif

typedef unsigned char BYTE;	//   Type BYTE definition

typedef unsigned short WCRC16;	//   Type CRC16 definition

//#define LOW(x)  ((short)x & 0x0FF)
//#define HIGH(x) ((short)x >> 8)
#define LOWB_DW(x)  ((unsigned long)x & 0x000000FF)
//#define BSW(x)	((((x) >> 8) & 0x00FF) | (((x) << 8) & 0xFF00))
//#define BSW(i) ( ((i<<8) & 0xFFFF) | ((i >>8) & 0xFFFF)); // swaps the bytes

#define     __I     volatile const          /*!< defines 'read only' permissions      */
#define     __O     volatile                  /*!< defines 'write only' permissions     */
#define     __IO    volatile                  /*!< defines 'read / write' permissions   */

/* define compiler specific symbols */
#if defined ( __CC_ARM   )
  #define __ASM            __asm                                      /*!< asm keyword for ARM Compiler          */
  #define __INLINE         __inline                                   /*!< inline keyword for ARM Compiler       */

#elif defined ( __ICCARM__ )
  #define __ASM           __asm                                       /*!< asm keyword for IAR Compiler          */
  #define __INLINE        inline                                      /*!< inline keyword for IAR Compiler. Only avaiable in High optimization mode! */

#elif defined   (  __GNUC__  )
  #define __ASM            __asm                                      /*!< asm keyword for GNU Compiler          */
  #define __INLINE         inline                                     /*!< inline keyword for GNU Compiler       */

#elif defined   (  __TASKING__  )
  #define __ASM            __asm                                      /*!< asm keyword for TASKING Compiler      */
  #define __INLINE         inline                                     /*!< inline keyword for TASKING Compiler   */

#endif
#endif
