/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	GPIO Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#include "gpio.h"



static volatile bool _Button = false;


/**
  * Brief   This function enables the peripheral clocks on GPIO port A and B,
  *         configures GPIO PB4 in output mode for the Green LED pin,
  *         configures GPIO PA5 in output mode for the Red LED pin,
  * Param   None
  * Retval  None
  */
void Configure_GPIO_LED(void)
{
  GPIO_InitTypeDef   GPIO_InitStructure;
  
  __GPIOA_CLK_ENABLE();
  __GPIOB_CLK_ENABLE();
  //RCC->IOPENR |= RCC_IOPENR_GPIOAEN;

  GPIO_InitStructure.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = B_LED_RED | B_LED_GREEN;
	GPIO_InitStructure.Speed = GPIO_SPEED_FAST;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStructure);  
  
  GPIO_InitStructure.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = A_LED_GELB;
	GPIO_InitStructure.Speed = GPIO_SPEED_FAST;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStructure);  

  LED_RED_HIGH();
  LED_GREEN_HIGH();
  LED_YELLOW_HIGH();
//  PIN_MODE_OUTPUT(GPIOA, PIN_LED_RED);
//  PIN_MODE_OUTPUT(GPIOA, PIN_LED_GREEN);
  
  //GPIO_MODE_OUTPUT(GPIOA, GPIO_LED_RED | GPIO_LED_GREEN, GPIO_OUT(PIN_LED_RED) | GPIO_OUT(PIN_LED_GREEN));
  
}

void  ConfigureGPIO(void)
{  
  GPIO_InitTypeDef   GPIO_InitStructure;
  
  __GPIOB_CLK_ENABLE();

  GPIO_InitStructure.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = B_CS;
	GPIO_InitStructure.Speed = GPIO_SPEED_FAST;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStructure);  

  GPIO_InitStructure.Mode = GPIO_MODE_INPUT;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = B_RST_RFM69;
	GPIO_InitStructure.Speed = GPIO_SPEED_FAST;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStructure);  
  
  GPIO_InitStructure.Mode  = GPIO_MODE_IT_RISING;
  GPIO_InitStructure.Pull  = GPIO_PULLDOWN; //GPIO_NOPULL;
  GPIO_InitStructure.Pin   = A_DIO0 | A_BUTTON;
	GPIO_InitStructure.Speed = GPIO_SPEED_FAST;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStructure);  


  NVIC_SetPriority(EXTI4_15_IRQn, 0); /* (4) */ 
  //NVIC_EnableIRQ(EXTI4_15_IRQn); /* (5) */ 
        
  //RCC->IOPENR |= RCC_IOPENR_GPIOBEN;
    //PIN_MODE_OUTPUT(GPIOB, PIN_CS);
    //PIN_MODE_OUTPUT(GPIOB, PIN_RST_RFM69);
    
    //GPIO_MODE_OUTPUT(GPIOB, GPIO_CS | GPIO_RST_RFM69, GPIO_OUT(PIN_CS) | GPIO_OUT(PIN_RST_RFM69));
    
    //PIN_HIGH_SPEED(GPIOB, PIN_CS);
    
    //PIN_MODE_INPUT(GPIOA, PIN_DIO0);
    //PIN_PULLDOWN(GPIOA, PIN_DIO0);
    
    
    
}

/**
  * Brief   This function configures EXTI.
  * Param   None
  * Retval  None
  */
//void Configure_EXTI(void)
//{
//  /* Configure Syscfg, exti and nvic for pushbutton PA0 */
//  /* (1) PA0 as source input */
//  /* (2) Unmask port 0 */
//  /* (3) Rising edge */
//  /* (4) Set priority */
//  /* (5) Enable EXTI0_1_IRQn */
//  SYSCFG->EXTICR[1] = (SYSCFG->EXTICR[1] & ~SYSCFG_EXTICR1_EXTI1) | SYSCFG_EXTICR1_EXTI0_PA; /* (1) */ 
//  EXTI->IMR |= EXTI_IMR_IM4; /* (2) */ 
//  EXTI->RTSR |= EXTI_RTSR_TR4; /* (3) */ 
//  NVIC_SetPriority(EXTI4_15_IRQn, 0); /* (4) */ 
//  NVIC_EnableIRQ(EXTI4_15_IRQn); /* (5) */ 
//}

bool getButton( void )
{
	//bool _Key = _Button;
	//_Button = false;
	return _Button;
}
void setButton( bool _Key )
{
	_Button = _Key;
}