/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	LED Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#include "led.h"
#include "clock.h"

static T_E_LED_GREEN_STATUS  teLedGreenStatus  = LED_GREEN_OFF;
static T_E_LED_RED_STATUS    teLedRedStatus    = LED_RED_OFF;
static T_E_LED_YELLOW_STATUS teLedYellowStatus = LED_YELLOW_OFF;


T_E_LED_GREEN_STATUS getLedGreenStatus( void )
{
	return teLedGreenStatus;
}

T_E_LED_RED_STATUS   getLedRedStatus( void )
{
	return teLedRedStatus;
}

T_E_LED_YELLOW_STATUS   getLedYellowStatus( void )
{
	return teLedYellowStatus;
}

void setLedGreenStatus( T_E_LED_GREEN_STATUS teLedStat )
{
	  teLedGreenStatus = teLedStat;
	  
	  if( teLedStat == LED_GREEN_OFF )
	  	{
	  		 LED_GREEN_HIGH();
	  	}
	  	else
	  		{  			
	  			LED_GREEN_LOW();
	  		}
	
}

void setLedRedStatus( T_E_LED_RED_STATUS teLedStat)
{
	  teLedRedStatus = teLedStat;
	  
	  if( teLedStat == LED_RED_OFF )
	  	{
	  		 LED_RED_HIGH();
	  	}
	  	else
	  		{
	  			LED_RED_LOW();
	  		}	  
	
}

void setLedYellowStatus( T_E_LED_YELLOW_STATUS teLedStat)
{
	  teLedYellowStatus = teLedStat;
	  
	  if( teLedStat == LED_YELLOW_OFF )
	  	{
	  		 LED_YELLOW_HIGH();
	  	}
	  	else
	  		{
	  			LED_YELLOW_LOW();
	  		}	  
	
}

void Blink(T_E_LED teLed, u32 dMs, u16 wLoops )
{
  u16 wCount;
  
  for (wCount=0; wCount<wLoops; wCount++)
  {
    if( teLed == LED_GREEN )
    	  setLedGreenStatus( LED_GREEN_ON );
    else if( teLed == LED_RED )
    	  setLedRedStatus(  LED_RED_ON );
    else
    	  setLedYellowStatus(  LED_YELLOW_ON );
    	  
    setTickCount( dMs ); //- ms
    while( !getTimeout());
    
    if( teLed == LED_GREEN )
    	  setLedGreenStatus( LED_GREEN_OFF );
    else if( teLed == LED_RED )
    	  setLedRedStatus(  LED_RED_OFF );
    else
    	  setLedYellowStatus(  LED_YELLOW_OFF );

    setTickCount( dMs ); //- ms
    while( !getTimeout());
        	      
//    digitalWrite(PIN,HIGH);
//    delay(DELAY_MS);
//    digitalWrite(PIN,LOW);
//    delay(DELAY_MS);
  }
  
}