/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	SPI Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#include "spi.h"




/**
  * Brief   This function :
             - Enables GPIO clock
             - Configures the SPI1 pins on GPIO PA4 PB3 PA6 PA7
  * Param   None
  * Retval  None
  */
void Configure_GPIO_SPI1(void)
{

  GPIO_InitTypeDef   GPIO_InitStructure;
  
  __GPIOA_CLK_ENABLE();
  
  GPIO_InitStructure.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = A_SCK | A_MISO | A_MOSI;
	GPIO_InitStructure.Speed = GPIO_SPEED_FAST;
	GPIO_InitStructure.Alternate = GPIO_AF0_SPI1;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStructure);  
    
  /* Enable the peripheral clock of GPIOA and GPIOB */
  //RCC->IOPENR |= RCC_IOPENR_GPIOAEN;
  //RCC->IOPENR |= RCC_IOPENR_GPIOBEN;
	
  /* (1) Select AF mode (10) on PA4, PA6, PA7 */
  /* (2) AF0 for SPI1 signals */
  /* (3) Select AF mode (10) on PB3 */
  /* (4) AF0 for SPI1 signals */
//  GPIOA->MODER = (GPIOA->MODER 
//                  & ~(GPIO_MODER_MODE5 | \
//                      GPIO_MODER_MODE6 | GPIO_MODER_MODE7))\
//                  | (GPIO_MODER_MODE5_1 | \
//                     GPIO_MODER_MODE6_1 | GPIO_MODER_MODE7_1); /* (1) */
//  
//  GPIOA->AFR[0] = (GPIOA->AFR[0] & \
//                   ~((0xF<<(4*5)) | \
//                     (0xF<<(4*6)) | ((uint32_t)0xF<<(4*7)))); /* (2) */
//   //GPIOB->MODER = (GPIOB->MODER & ~(GPIO_MODER_MODE3)) | GPIO_MODER_MODE3_1; /* (3) */
//   //GPIOB->AFR[0] = (GPIOB->AFR[0] & ~((0xF<<(4*3)))); /* (4) */
//   
//   PIN_HIGH_SPEED(GPIOA, PIN_SCK);
//   PIN_HIGH_SPEED(GPIOA, PIN_MISO);
//   PIN_HIGH_SPEED(GPIOA, PIN_MOSI);
   
}

/**
  * Brief   This function configures SPI1.
  * Param   None
  * Retval  None
  */
void Configure_SPI1(void)
{
  /* Enable the peripheral clock SPI1 */
  RCC->APB2ENR |= RCC_APB2ENR_SPI1EN;

  /* Configure SPI2 in master */
  /* CPOL and CPHA at low (falling first edge) */
  /* (1) 8-bit  */
  /* (2) Enable SPI1 */
  SPI_RF_MODUL->CR1  = SPI_CR1_MSTR | SPI_CR1_SSI | SPI_CR1_SSM;
  SPI_RF_MODUL->CR2  = 0; /* (1) */
  SPI_RF_MODUL->CR1 |= SPI_CR1_SPE; /* (2) */
}
