/******************************************************************************
*                            Steffen Hofmann                                  *
*                            mcu@shotech.de                                   *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  12.03.2017 20:24:04
*  Geraete Bezeichnung   :  RFM69CW-RF-Modul
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	USART Projekt RFM69CW-RF-Modul
* 
*
******************************************************************************/

#include "usart.h"




/**
  * Brief   This function :
             - Enables GPIO clock
             - Configures the USART1 pins on GPIO PA9 PA10
  * Param   None
  * Retval  None
  */
void Configure_GPIO_USART1(void)
{
  GPIO_InitTypeDef   GPIO_InitStructure;
  
  __GPIOA_CLK_ENABLE();

  GPIO_InitStructure.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = A_TX1 | A_RX1;
	GPIO_InitStructure.Speed = GPIO_SPEED_FAST;
	GPIO_InitStructure.Alternate = GPIO_AF4_USART1;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStructure);  

  /* Enable the peripheral clock of GPIOA */
  //RCC->IOPENR |= RCC_IOPENR_GPIOAEN;
	
  /* GPIO configuration for USART1 signals */
  /* (1) Select AF mode (10) on PA9 and PA10 */
  /* (2) AF4 for USART1 signals */
//  GPIOA->MODER = (GPIOA->MODER & ~(GPIO_MODER_MODE9|GPIO_MODER_MODE10))\
//                 | (GPIO_MODER_MODE9_1 | GPIO_MODER_MODE10_1); /* (1) */
  
//  GPIO_MODE_ALTERNATE(GPIOA, GPIO_TX1 | GPIO_RX1, GPIO_ALT(PIN_TX1) | GPIO_ALT(PIN_RX1) );
  
  //PIN_ALTERNATE_HIGH_AF4( GPIOA, PIN_TX1);
  //PIN_ALTERNATE_HIGH_AF4( GPIOA, PIN_RX1);
  
//  GPIOA->AFR[1] = (GPIOA->AFR[1] &~ (0x00000FF0))\
//                  | (4 << (1 * 4)) | (4 << (2 * 4)); /* (2) */
}

/**
  * Brief   This function configures USART1.
  * Param   None
  * Retval  None
  */
void Configure_USART1(void)
{
  /* Enable the peripheral clock USART1 */
  RCC->APB2ENR |= RCC_APB2ENR_USART1EN;

  /* Configure USART1 */
  /* (1) oversampling by 16, 9600 baud */
  /* (2) 8 data bit, 1 start bit, 1 stop bit, no parity */
  USART1->BRR = 160000 / 96; /* (1) */
  USART1->CR1 = USART_CR1_TE | USART_CR1_RE | USART_CR1_UE; /* (2) */
  
  /* polling idle frame Transmission */
  while((USART1->ISR & USART_ISR_TC) != USART_ISR_TC)
  { 
    /* add time out here for a robust application */
  }
  USART1->ICR = USART_ICR_TCCF;/* clear TC flag */
  //USART1->CR1 |= USART_CR1_TCIE;/* enable TC interrupt */
  
  /* Configure IT */
  /* (3) Set priority for USART1_IRQn */
  /* (4) Enable USART1_IRQn */
  //NVIC_SetPriority(USART1_IRQn, 0); /* (3) */
  //NVIC_EnableIRQ(USART1_IRQn); /* (4) */
}